CREATE OR REPLACE
TRIGGER GERA_HISTORICO_BEM
BEFORE INSERT OR UPDATE OR DELETE
ON BEMATIVO FOR EACH ROW 
DECLARE

   V_NEW_DATA  VARCHAR2(10);
   V_OLD_DATA  VARCHAR2(10);
BEGIN

   IF UPDATING THEN
      IF :NEW.DTBAIXATOTABEMA IS NULL THEN
         V_NEW_DATA := ' ';
      ELSE
         V_NEW_DATA := TO_CHAR(:NEW.DTBAIXATOTABEMA,'DD/MM/YYYY');
      END IF;
      IF :OLD.DTBAIXATOTABEMA IS NULL THEN
         V_OLD_DATA := ' ';
      ELSE
         V_OLD_DATA := TO_CHAR(:OLD.DTBAIXATOTABEMA,'DD/MM/YYYY');
      END IF;
      IF (NVL(:OLD.NMBEMATIVO,0) <> NVL(:NEW.NMBEMATIVO,0)) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST)
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:NEW.NMBEMATIVO,
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 NVL(:OLD.NMBEMATIVO,0),NVL(:NEW.NMBEMATIVO,0),'01','Nome do Bem',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF;
      IF (NVL(:OLD.NMABREVBEMATIVO,0) <> NVL(:NEW.NMABREVBEMATIVO,0)) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST)
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO,
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 NVL(:OLD.NMABREVBEMATIVO,0),NVL(:NEW.NMABREVBEMATIVO,0),'02','Nome Abreviado',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF;
      IF (NVL(:OLD.CDPATRIBEMATIVO,0) <> NVL(:NEW.CDPATRIBEMATIVO,0)) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST)
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO,
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 NVL(:OLD.CDPATRIBEMATIVO,0),NVL(:NEW.CDPATRIBEMATIVO,0),'03','Cdigo do Patrimnio',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF;
      IF (NVL(:OLD.CDFORNECED,0) <> NVL(:NEW.CDFORNECED,0)) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST)
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO,
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 NVL(:OLD.CDFORNECED,0),NVL(:NEW.CDFORNECED,0),'04','Fornecedor',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF;
      IF (NVL(:OLD.NRNOTAFISCBEM,0) <> NVL(:NEW.NRNOTAFISCBEM,0)) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST)
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO,
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 NVL(:OLD.NRNOTAFISCBEM,0),NVL(:NEW.NRNOTAFISCBEM,0),'05','Nota Fiscal de Entrada',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF;
      IF (NVL(:OLD.DTAQUIBEMATIVO,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTAQUIBEMATIVO,TO_DATE('31/12/1899','DD/MM/YYYY'))) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST)
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO,
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 NVL(:OLD.DTAQUIBEMATIVO,TO_DATE('31/12/1899','DD/MM/YYYY')),
                 NVL(:NEW.DTAQUIBEMATIVO,TO_DATE('31/12/1899','DD/MM/YYYY')),'06','Data de Aquisio',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF;
      IF (NVL(:OLD.CDPRODUTO,0) <> NVL(:NEW.CDPRODUTO,0)) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST)
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO,
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 NVL(:OLD.CDPRODUTO,0),NVL(:NEW.CDPRODUTO,0),'07','Produto',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF;
      IF (NVL(:OLD.QTATUABEMATIVO,0) <> NVL(:NEW.QTATUABEMATIVO,0)) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST)
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO,
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 NVL(:OLD.QTATUABEMATIVO,0),NVL(:NEW.QTATUABEMATIVO,0),'08','Quantidade Atual',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF;
      IF (NVL(:OLD.SGUNIDADE,0) <> NVL(:NEW.SGUNIDADE,0)) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST)
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO,
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 NVL(:OLD.SGUNIDADE,0),NVL(:NEW.SGUNIDADE,0),'09','Unidade de Medida',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF; 
      IF (NVL(:OLD.VRAQUIBEMATIVO,0) <> NVL(:NEW.VRAQUIBEMATIVO,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.VRAQUIBEMATIVO,0),NVL(:NEW.VRAQUIBEMATIVO,0),'10','Valor de Aquisio',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDCENTCUST,0) <> NVL(:NEW.CDCENTCUST,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDCENTCUST,0),NVL(:NEW.CDCENTCUST,0),'11','Centro de Custo',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.DTINIUSOBEM,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTINIUSOBEM,TO_DATE('31/12/1899','DD/MM/YYYY'))) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.DTINIUSOBEM,TO_DATE('31/12/1899','DD/MM/YYYY')), 
                 NVL(:NEW.DTINIUSOBEM,TO_DATE('31/12/1899','DD/MM/YYYY')),'12','Data inicio Uso',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDGRUPOBEM,0) <> NVL(:NEW.CDGRUPOBEM,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDGRUPOBEM,0),NVL(:NEW.CDGRUPOBEM,0),'13','Grupo de Bem',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDTIPODEPREC,0) <> NVL(:NEW.CDTIPODEPREC,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDTIPODEPREC,0),NVL(:NEW.CDTIPODEPREC,0),'14','Tipo de Depreciao',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.IDNOVOUSABEM,0) <> NVL(:NEW.IDNOVOUSABEM,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.IDNOVOUSABEM,0),NVL(:NEW.IDNOVOUSABEM,0),'15','Usado/Novo',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.QTMESUSOBEM,0) <> NVL(:NEW.QTMESUSOBEM,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.QTMESUSOBEM,0),NVL(:NEW.QTMESUSOBEM,0),'17','Vida til Ms',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.VRTAXANODEPBEM,0) <> NVL(:NEW.VRTAXANODEPBEM,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.VRTAXANODEPBEM,0),NVL(:NEW.VRTAXANODEPBEM,0),'18','Taxa de depreciao anual',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.VRINIDEPBEM,0) <> NVL(:NEW.VRINIDEPBEM,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.VRINIDEPBEM,0),NVL(:NEW.VRINIDEPBEM,0),'19','Valor inicial para depreciao',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.DTINIDEPRECBEM,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTINIDEPRECBEM,TO_DATE('31/12/1899','DD/MM/YYYY'))) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.DTINIDEPRECBEM,TO_DATE('31/12/1899','DD/MM/YYYY')), 
                 NVL(:NEW.DTINIDEPRECBEM,TO_DATE('31/12/1899','DD/MM/YYYY')),'20','Data inicial para depreciao',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.DTBAIXATOTABEMA,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTBAIXATOTABEMA,TO_DATE('31/12/1899','DD/MM/YYYY'))) THEN
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM,
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM,
                 V_OLD_DATA, V_NEW_DATA,'21','Data da Baixa Total',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF; 
      IF (NVL(:OLD.DTBAIXAPARCBEMA,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTBAIXAPARCBEMA,TO_DATE('31/12/1899','DD/MM/YYYY'))) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 V_OLD_DATA, V_NEW_DATA,'33','Data da Baixa Parcial',NVL(:NEW.CDPATRIBEMATIVO,0));
      END IF; 
      IF (NVL(:OLD.CDFILIAL,0) <> NVL(:NEW.CDFILIAL,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDFILIAL,0),NVL(:NEW.CDFILIAL,0),'22','Filial de Localizao',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDSETOR,0) <> NVL(:NEW.CDSETOR,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDSETOR,0),NVL(:NEW.CDSETOR,0),'23','Setor de Localizao',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.DSLOCALBEMATIVO,0) <> NVL(:NEW.DSLOCALBEMATIVO,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST, NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.DSLOCALBEMATIVO,0),NVL(:NEW.DSLOCALBEMATIVO,0),'24','Descrio de Localizao',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDOPERADOR,0) <> NVL(:NEW.CDOPERADOR,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDOPERADOR,0),NVL(:NEW.CDOPERADOR,0),'25','Responsvel',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDCLASSIFICABEM,0) <> NVL(:NEW.CDCLASSIFICABEM,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDCLASSIFICABEM,0),NVL(:NEW.CDCLASSIFICABEM,0),'26','Classificao',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDESTCONSERVA,0) <> NVL(:NEW.CDESTCONSERVA,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDESTCONSERVA,0),NVL(:NEW.CDESTCONSERVA,0),'27','Estado de Conservao',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDREGIMEBEM,0) <> NVL(:NEW.CDREGIMEBEM,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDREGIMEBEM,0),NVL(:NEW.CDREGIMEBEM,0),'28','Regime',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDBEMPRINCIPAL,0) <> NVL(:NEW.CDBEMPRINCIPAL,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDBEMPRINCIPAL,0),NVL(:NEW.CDBEMPRINCIPAL,0),'29','Agregado Principal',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDBARRABEMATIVO,0) <> NVL(:NEW.CDBARRABEMATIVO,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDBARRABEMATIVO,0),NVL(:NEW.CDBARRABEMATIVO,0),'30','Cdigo de Barras',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDSERIEENTRBEM,0) <> NVL(:NEW.CDSERIEENTRBEM,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDSERIEENTRBEM,0),NVL(:NEW.CDSERIEENTRBEM,0),'31','n Srie Nota Fiscal de Entrada',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDFABRIC,0) <> NVL(:NEW.CDFABRIC,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDFABRIC,0),NVL(:NEW.CDFABRIC,0),'34','Fabricante',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
      IF (NVL(:OLD.CDMODELO,0) <> NVL(:NEW.CDMODELO,0)) THEN 
         INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                                  DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
         VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
                 (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:NEW.CDOPERATUBEM, 
                 NVL(:OLD.CDMODELO,0),NVL(:NEW.CDMODELO,0),'16','Modelo',NVL(:NEW.CDPATRIBEMATIVO,0)); 
      END IF; 
   END IF;    
   IF DELETING THEN  
      INSERT INTO HISTORICOBEM(CDEMPRESA,CDBEMHIST,NMBEMATIVOHIST,NRSEQHISTBEM,DTATUHISTBEM,CDOPEATUHBEM, 
                               DSINFOANTHBEM,DSINFOPOSHBEM,IDATUHISTBEM,DSATUHISTBEM,CDPATRIBEMHIST) 
      VALUES (:OLD.CDEMPRESA,:OLD.CDBEMATIVO,:OLD.NMBEMATIVO, 
              (SELECT LPAD((NVL(MAX(NRSEQHISTBEM),0)+1),10,'0') FROM HISTORICOBEM),SYSDATE,:OLD.CDOPERATUBEM, 
              NVL(:OLD.NMBEMATIVO,0),'Bem Excluido','32','Excluso do Bem',NVL(:NEW.CDPATRIBEMATIVO,0)); 
   END IF;           
END; 

/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_HISTORICO_BEM','5.05.076'); END;
/

