TRUNCATE TABLE CUSTOCMPPROD
GO
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'ATUALIZA_CUSTO_CMP'  AND
	        TYPE = 'P' 			       AND
	        U.UID = O.UID             AND
	        U.NAME = USER)

DROP PROCEDURE ATUALIZA_CUSTO_CMP
GO

CREATE PROCEDURE ATUALIZA_CUSTO_CMP

AS

   DECLARE @V_CDTIPOOPER VARCHAR(02);

   DECLARE @V_LANCTOEST    DOUBLE PRECISION;
   DECLARE @V_CDFILIMOVI   VARCHAR(04);
   DECLARE @V_NRLANCTONF   VARCHAR(10);

/* VARIVEIS DO CURSOR C_LANCAMEN */
   DECLARE @V_DTLANCMOVI   DATETIME;
   DECLARE @V_CDPRODUTO    VARCHAR(10);
   DECLARE @V_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_CDLOCALESTOQ VARCHAR(06);
   DECLARE @V_NRLOTEESTQ   VARCHAR(20);
   DECLARE @V_NRSUBLOTE    VARCHAR(04);
   DECLARE @V_NRLANCESTQ   VARCHAR(10);
   DECLARE @V_CDFILIAL     VARCHAR(04);



BEGIN
   DECLARE C_LANCAMEN CURSOR FOR
      SELECT DTLANCMOVI,  C.CDPRODUTO,
             A.CDALMOXARIFE,   A.CDLOCALESTOQ, A.NRLOTEESTQ,
             A.NRSUBLOTE,      MAX(D.NRLANCESTQ) AS NRLANCESTQ,
             D.CDFILIMOVI
      FROM ITLANCTOEST A, PRODUTO B, PRODFILI C, LANCTOESTOQ D
      WHERE (D.CDFILIAL   = A.CDFILIAL)   AND
            (D.NRLANCESTQ = A.NRLANCESTQ) AND
            (B.CDPRODUTO  = A.CDPRODUTO)  AND
            (C.CDFILIAL   = A.CDFILIMOVI) AND
            (C.CDPRODUTO  = A.CDPRODMOVI) AND
            (IDTPLANCTO   IN( 'E','2', '0'))
      GROUP BY D.CDFILIMOVI, A.DTLANCMOVI,  C.CDPRODUTO,   A.CDALMOXARIFE, A.CDLOCALESTOQ,
               A.NRLOTEESTQ,  A.NRSUBLOTE,   IDTPLANCTO
      ORDER BY D.CDFILIMOVI, A.DTLANCMOVI,  C.CDPRODUTO, IDTPLANCTO

   OPEN C_LANCAMEN;
   FETCH NEXT FROM C_LANCAMEN INTO @V_DTLANCMOVI,
                                   @V_CDPRODUTO,
                                   @V_CDALMOXARIFE,
                                   @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                                   @V_NRSUBLOTE,    @V_NRLANCESTQ,
                                   @V_CDFILIMOVI;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_CDFILIAL     = MAX(L.CDFILIAL)
      FROM ITLANCTOEST I, LANCTOESTOQ L
      WHERE I.CDFILIAL   = L.CDFILIAL      AND
            I.NRLANCESTQ = L.NRLANCESTQ    AND
            I.CDPRODUTO  = @V_CDPRODUTO    AND
            I.CDFILIMOVI = @V_CDFILIMOVI   AND
            I.NRLANCESTQ = @V_NRLANCESTQ;


      EXEC CUSTO_LIQUIDO @V_CDFILIAL, @V_NRLANCESTQ, 0;

      FETCH NEXT FROM C_LANCAMEN INTO @V_DTLANCMOVI,
                                      @V_CDPRODUTO,
                                      @V_CDALMOXARIFE,
                                      @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                                      @V_NRSUBLOTE,    @V_NRLANCESTQ,
                                      @V_CDFILIMOVI;

   END;

   CLOSE C_LANCAMEN;
   DEALLOCATE C_LANCAMEN;

END;

GO

BEGIN

EXEC ATUALIZA_CUSTO_CMP;

END;

GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_CUSTO_CMP','4.05.053';
GO

